;;;; -*- lisp -*-

(in-package :it.bese.yaclml)

;;;; We'de like to use FiveAM for this, but unfortunetly every minor
;;;; change to the code may change the output just slightly, which
;;;; makes auto testing a pain. we'll just "eyeball" it for now.

(defun test-tal (html &rest envs)
  (let ((func (compile-tal-string html)))
    (with-yaclml-stream nil
      (dolist (env envs)
	(funcall func env)
	(terpri)))))

(test-tal "<a/>" nil)

(test-tal "

<pre>

  one

two
</pre>" nil)

(test-tal "<a><span/><a>" nil)

(test-tal
 "<a href=\"4\" tal:when=\"$c\"> OK! </a>"
 `(:c t)) 

(test-tal
 "<a href=\"4\" tal:when=\"(not $c)\"> OK! </a>"
 `(:c nil)
 nil
 `(:c 4))

(test-tal
 "<a href=\"BAD\" tal:replace=\"$c\">BAD BAD BAD</a>"
 `(:c "OK!"))

(test-tal
 "<a tal:content=\"$c\">BAD BAD BAD</a>"
 `(:C "OK!"))

(test-tal
 "<tal/>"
 nil)

(test-tal
 "<tal tal:dolist=\"$c\">
    <tal tal:replace=\"$v\">BAD</tal>
  </tal>"
 `(:c ((:v " OK1 ") (:v " OK2 "))))

(test-tal
 "<tal tal:replace=\"$C\"/>"
 `(:C "OK!"))

(test-tal
 "<ul tal:when=\"$c\">
    <li>D: <tal tal:replace=\"$c\"></li>
    <li>E: <tal tal:replace=\"$c\"></li>
  </ul>"
 `(:C nil :D "DD" :E "EE")
 `(:C t :D "DD" :E "EE"))

(test-tal
 "<ul tal:when=\"$c\">
    <tal tal:dolist=\"$c\">
      <li> --<tal tal:replace=\"$d\">BAD</tal>-- </li>
      <li> --<tal tal:replace=\"$e\">BAD</tal>-- </li>
    </tal>
  </ul>"
 '(:C ((:D 1 :E 2) (:D 1 :E 2) (:D 1 :E 2))))
